P365/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.urls import include, path
from django.contrib import admin
from django.contrib.auth.views import logout_then_login

import calendar_year.urls
import profile.urls
import story.urls
import table.urls
import tag.urls
from map import urls_map, urls_poi, urls_route, urls_track
from profile.views import LoginView, ProfileRedirect, SignUpView, IndexView

urlpatterns = [
    # main
    path('',            IndexView.as_view(),        name='index'),
    path('admin/',      admin.site.urls,),
    path('summernote/', include('django_summernote.urls')),
    # auth
    path('login/',      LoginView.as_view(),        name='login'),
    path('register/',   SignUpView.as_view(),       name='signup'),
    path('logout/',     logout_then_login,          name='logout'),
    # redirection
    path('accounts/profile/', ProfileRedirect.as_view()),
    # tabs
    path('calendar/',   include(calendar_year.urls, namespace='calendar')),
    path('map/',        include(urls_map,           namespace='map')),
    path('table/',      include(table.urls,         namespace='table')),
    path('story/',      include(story.urls,         namespace='story')),
    # other
    path('user/',       include(profile.urls,       namespace='user')),
    path('poi/',        include(urls_poi,           namespace='poi')),
    path('route/',      include(urls_route,         namespace='route')),
    path('track/',      include(urls_track,         namespace='track')),
    path('tag/',        include(tag.urls,           namespace='tag')),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

profile/urls.py
from django.urls import path

from table.views import TableView
from .views import ProfileView

app_name = 'user'

urlpatterns = [
    path('<slug:username>/',        ProfileView.as_view(),  name='profile'),
    path('<slug:username>/table/',  TableView.as_view(),    name='table')
]

story/urls.py
from django.urls import path, register_converter

from P365.converters import UintWithoutZero
from .views import StoriesView, StoryView, StoryEditView, JSONStoryDeleteView

app_name = 'story'

register_converter(UintWithoutZero, 'uint_id')

urlpatterns = [
    path('',                          StoriesView.as_view(),         name='stories'),
    path('<uint_id:id>/',             StoryView.as_view(),           name='view'),
    path('<uint_id:id>/edit/',        StoryEditView.as_view(),       name='edit'),
    path('<uint_id:id>/json_delete/', JSONStoryDeleteView.as_view(), name='json_delete'),
    path('create/',                   StoryEditView.as_view(),       name='create'),
]

tag/urls.py
from django.urls import path

from .views import TagCloudView, TagView

app_name = 'tag'

urlpatterns = [
    path('',                TagCloudView.as_view(), name='tag_cloud'),
    path('<slug:tagslug>/', TagView.as_view(),      name='tag'),
]

profile/models.py
from django.contrib.auth.models import User
from django.db import models
from django.db.models.signals import post_save
from django.dispatch import receiver


def avatar_user_path(instance, filename):
    return f'avatars/{instance.user.username}.{filename.split(".")[-1]}'


class ProfileModel(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    info = models.TextField(max_length=100, blank=True)
    location = models.CharField(max_length=30, blank=True)
    pic = models.ImageField(upload_to=avatar_user_path, default='avatars/default/default.png')
    fb_url = models.CharField(max_length=100, blank=True)
    tw_url = models.CharField(max_length=100, blank=True)
    ig_url = models.CharField(max_length=100, blank=True)

    objects = models.Manager()

    def __str__(self):
        return self.user.username


@receiver(post_save, sender=User)
def create_user_profile(instance, created, **__):
    if created:
        ProfileModel.objects.create(user=instance)


@receiver(post_save, sender=User)
def save_user_profile(instance,  **__):
    instance.profilemodel.save()

profile/forms.py
from django import forms
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User


class SignUpForm(UserCreationForm):
    first_name = forms.CharField(max_length=30, required=False, help_text='Optional.')
    last_name = forms.CharField(max_length=30, required=False, help_text='Optional.')
    email = forms.EmailField(max_length=254, help_text='Required. Inform a valid email address')

    class Meta:
        model = User
        fields = ('username', 'first_name', 'last_name', 'email', 'password1', 'password2')

profile/views.py
from datetime import timedelta

from django.contrib.auth import authenticate, login
from django.contrib.auth.forms import AuthenticationForm
from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.auth.models import User
from django.db.models import Sum, Q, Max
from django.http import HttpResponseRedirect
from django.shortcuts import render, get_object_or_404
from django.urls import reverse
from django.views import View

from map.models import TrackModel, RouteModel
from story.models import StoryModel
from .forms import SignUpForm
from .models import ProfileModel


class IndexView(View):
    @staticmethod
    def get(request):
        return render(request, 'index.html', {'title': 'Index'})


class LoginView(View):
    @staticmethod
    def get(request):
        if request.user.is_authenticated:
            return HttpResponseRedirect(reverse('user:profile', kwargs={'username': request.user}))
        else:
            form = AuthenticationForm()
            nexturl = request.GET.get('next') or ''
            return render(request, 'login.html', {'title': 'Login', 'form': form, 'next': nexturl})

    @staticmethod
    def post(request):
        form = AuthenticationForm(data=request.POST)
        nexturl = request.GET.get('next')
        if form.is_valid():
            user = User.objects.get(username=form.cleaned_data['username'])
            login(request, user)
            return HttpResponseRedirect(nexturl or reverse('user:profile', kwargs={'username': request.user}))
        else:
            return render(request, 'login.html', {'title': 'Login', 'form': form, 'next': nexturl})


class SignUpView(View):
    @staticmethod
    def get(request):
        if request.user.is_authenticated:
            return HttpResponseRedirect(reverse('user:profile', kwargs={'username': request.user}))
        else:
            form = SignUpForm()
            nexturl = request.GET.get('next') or ''
            return render(request, 'register.html', {'title': 'Sign Up', 'form': form, 'next': nexturl})

    @staticmethod
    def post(request):
        form = SignUpForm(data=request.POST)
        nexturl = request.GET.get('next')
        if form.is_valid():
            form.save()
            user = authenticate(request, username=request.POST['username'], password=request.POST['password1'])
            if user:
                login(request, user)
            return HttpResponseRedirect(nexturl or reverse('user:profile', kwargs={'username': user.username}))
        else:
            return render(request, 'register.html', {'title': 'Sign Up', 'form': form, 'next': nexturl})


class ProfileRedirect(LoginRequiredMixin, View):
    @staticmethod
    def get(request):
        return HttpResponseRedirect(reverse('user:profile', kwargs={'username': request.user}))


class ProfileView(LoginRequiredMixin, View):
    @staticmethod
    def get(request, username):
        profile = get_object_or_404(ProfileModel, user__username=username)
        tracks = TrackModel.objects.filter(user__username=username, is_active=True)
        routes = RouteModel.objects.filter(user__username=username, is_active=True)
        stories = StoryModel.objects.filter(user__username=username, is_active=True)
        if request.user.username != username:
            tracks, routes = tracks.filter(public=True), routes.filter(public=True)
        counter = {'tracks': tracks.count(), 'routes': routes.count(), 'stories': stories.count()}
        total_time = timedelta()
        for track in tracks:
            total_time += track.finish_date - track.start_date
        stat = {
            'walking': tracks.filter(Q(tags__name='walking')).aggregate(Sum('length'))['length__sum'] or 0,
            'hiking': tracks.filter(Q(tags__name='hiking')).aggregate(Sum('length'))['length__sum'] or 0,
            'running': tracks.filter(Q(tags__name='running')).aggregate(Sum('length'))['length__sum'] or 0,
            'cycling': tracks.filter(Q(tags__name='cycling')).aggregate(Sum('length'))['length__sum'] or 0,
            'swimming': tracks.filter(Q(tags__name='swimming')).aggregate(Sum('length'))['length__sum'] or 0,
            'skiing': tracks.filter(Q(tags__name='skiing')).aggregate(Sum('length'))['length__sum'] or 0,
            'distance': tracks.aggregate(Sum('length'))['length__sum'],
            'rise': (tracks.aggregate(Sum('altitude_gain'))['altitude_gain__sum'] or 0) / 1000,
            'fall': (tracks.aggregate(Sum('altitude_loss'))['altitude_loss__sum'] or 0) / 1000,
            'peak': tracks.aggregate(Max('altitude_max'))['altitude_max__max'],
            'max_speed': tracks.aggregate(Max('speed_max'))['speed_max__max'],
            'time': {
                'hours': int(total_time.total_seconds() // 3600),
                'minutes': int(total_time.total_seconds() % 3600 // 60)
            }
        }
        return render(request, 'profile.html', {
            'title': 'Profile',
            'profile': profile,
            'counter': counter,
            'stat': stat,
        })

tag/views.py
from django.db.models import Q
from django.shortcuts import render
from django.views import View
from taggit.models import Tag

from map.models import POIModel, RouteModel, TrackModel
from story.models import StoryModel


class TagCloudView(View):
    @staticmethod
    def get(request):
        return render(request, 'tag-cloud.html', {
            'title': 'Tagcloud',
        })


class TagView(View):
    @staticmethod
    def get(request, tagslug):
        tag = Tag.objects.get(slug=tagslug)
        stories = StoryModel.objects.filter(
            Q(tags=tag), Q(is_active=True)
        ).order_by('-created')
        if request.user.is_anonymous:
            pois = POIModel.objects.filter(tags=tag, is_active=True, public=True).order_by('-created')
            routes = RouteModel.objects.filter(tags=tag, is_active=True, public=True).order_by('-created')
            tracks = TrackModel.objects.filter(tags=tag, is_active=True, public=True).order_by('-start_date')
        else:
            pois = POIModel.objects.filter(
                Q(tags=tag), Q(is_active=True), Q(user=request.user) | Q(public=True)
            ).order_by('-created')
            routes = RouteModel.objects.filter(
                Q(tags=tag), Q(is_active=True), Q(user=request.user) | Q(public=True)
            ).order_by('-created')
            tracks = TrackModel.objects.filter(
                Q(tags=tag), Q(is_active=True), Q(user=request.user) | Q(public=True)
            ).order_by('-start_date')
        return render(request, 'tag.html', {
            'title': '#' + tagslug,
            'tag': tag,
            'pois': pois,
            'routes': routes,
            'tracks': tracks,
            'stories': stories,
        })

templates/partials/_pois-table.html
{% load humanize %}
{% load taggit_templatetags2_tags %}

{% if pois %}
<table class="table table-dark table-striped table-hover table-sm">
    <caption class="sr-only">POIs table</caption>
    <thead>
    <tr>
        <th>Name</th>
        <th>Created</th>
        <th class="text-center">Tags</th>
        <th class="text-center">Status</th>
        <th class="text-center">Edit</th>
    </tr>
    </thead>
    <tbody>
    {% for poi in pois %}
    <tr id="poi{{ poi.id }}">
        <td>
            <a href="{% url 'poi:view' poi.id %}">{{ poi.name }}</a>
        </td>
        <td>{{ poi.created|naturaltime }}</td>
        <td class="text-center">
            {% get_tags_for_object poi as 'tags' %}
            {% for tag in tags|slice:':3' %}
            <a href="{% url 'tag:tag' tag.slug %}" class="badge badge-pill badge-secondary">{{ tag }}</a>
            {% endfor %}
            {% if tags|length > 3 %}
            <i class="badge badge-pill badge-secondary">...</i>
            {% endif %}
        </td>
        <td class="text-center status">
            {% if poi.public %}
            <a href="#" title="public"><i class="fa fa-globe"></i></a>
            {% else %}
            <a href="#" title="private"><i class="fas fa-user-lock"></i></a>
            {% endif %}
        </td>
        <td class="text-center edit">
            <a href="{% url 'poi:edit' poi.id %}" title="edit"><i class="fas fa-edit"></i></a>
            {% if not poi.public %}
            <a href="#" title="delete"><i class="fa fa-trash"></i></a>
            {% endif %}
        </td>
    </tr>
    {% endfor %}
    </tbody>
</table>
{% else %}
<div class="alert alert-info" role="alert">
    {% if active %}
    You don't have pois yet. Try to <a href="{% url 'poi:create' %}" class="alert-link">create your first poi</a>
    {% else %}
    <a href="{% url 'user:profile' profile %}"><b>{{ profile }}</b></a> has no public pois yet
    {% endif %}
</div>
{% endif %}

templates/partials/_profile-fullscreen.html
<div class="card text-white bg-dark">
    <div class="card-body">
        <div class="row">
            <div class="col-6">
                <div class="card-text">
                    <img src="{{ profile.pic.url }}" alt="Profile pic" style="height: 100px;"/>
                </div>
            </div>
            <div class="col-6">
                <div class="card-title" id="username">
                    <a href="{% url 'user:profile' profile.user %}">{{ profile.user }}</a>
                </div>
                <div class="card-text">
                    {% if profile.info %} {{ profile.info }} {% endif %}
                </div>
                <div class="card-text">
                    {% if profile.location %}<i class="fa fa-map-marker"></i> {{ profile.location }} {% endif %}
                </div>
            </div>
        </div>
        <div class="card-group" id="counters">
            <div class="card text-white bg-success col-4">
                <a class="btn" href="{% url 'user:table' profile.user %}#tracks">
                    <div class="card-text">Tracks</div>
                    <div class="card-title">{{ counter.tracks|default:0 }}</div>
                </a>
            </div>
            <div class="card text-white bg-success col-4">
                <a class="btn" href="{% url 'user:table' profile.user %}#routes">
                    <div class="card-text">Routes</div>
                    <div class="card-title">{{ counter.routes|default:0 }}</div>
                </a>
            </div>
            <div class="card text-white bg-success col-4">
                <a class="btn" href="#">
                    <div class="card-text">Stories</div>
                    <div class="card-title">{{ counter.stories|default:0 }}</div>
                </a>
            </div>
        </div>
        <div class="text-center" id="socials">
            {% if profile.fb_url %}
                <a href="{{ profile.fb_url }}" target="_blank"><i class="fab fa-facebook-square fa-3x"></i></a>
            {% endif %}
            {% if profile.tw_url %}
                <a href="{{ profile.tw_url }}" target="_blank"><i class="fab fa-twitter-square fa-3x"></i></a>
            {% endif %}
            {% if profile.ig_url %}
                <a href="{{ profile.ig_url }}" target="_blank"><i class="fab fa-instagram fa-3x"></i></a>
            {% endif %}
        </div>
    </div>
</div>

templates/partials/_profile.html
<div class="card text-white bg-dark">
    <img class="card-img-top" src="{{ profile.pic.url }}" alt="Profile pic"/>
    <div class="card-body">
        <div class="card-title" id="username">
            <a href="{% url 'user:profile' profile.user %}">{{ profile.user }}</a>
        </div>
        <div class="card-text">
            {% if profile.info %} {{ profile.info }} {% endif %}
        </div>
        <div class="card-text">
            {% if profile.location %}<i class="fa fa-map-marker"></i> {{ profile.location }} {% endif %}
        </div>
        <div class="card-group" id="counters">
            <div class="card text-white bg-success col-4">
                <a class="btn" href="{% url 'user:table' profile.user %}#tracks">
                    <div class="card-text">Tracks</div>
                    <div class="card-title">{{ counter.tracks|default:0 }}</div>
                </a>
            </div>
            <div class="card text-white bg-success col-4">
                <a class="btn" href="{% url 'user:table' profile.user %}#routes">
                    <div class="card-text">Routes</div>
                    <div class="card-title">{{ counter.routes|default:0 }}</div>
                </a>
            </div>
            <div class="card text-white bg-success col-4">
                <a class="btn" href="#">
                    <div class="card-text">Stories</div>
                    <div class="card-title">{{ counter.stories|default:0 }}</div>
                </a>
            </div>
        </div>
        <div class="text-center" id="socials">
            {% if profile.fb_url %}
                <a href="{{ profile.fb_url }}" target="_blank"><i class="fab fa-facebook-square fa-3x"></i></a>
            {% endif %}
            {% if profile.tw_url %}
                <a href="{{ profile.tw_url }}" target="_blank"><i class="fab fa-twitter-square fa-3x"></i></a>
            {% endif %}
            {% if profile.ig_url %}
                <a href="{{ profile.ig_url }}" target="_blank"><i class="fab fa-instagram fa-3x"></i></a>
            {% endif %}
        </div>
    </div>
</div>

templates/partials/_routes-table.html
{% load humanize %}
{% load taggit_templatetags2_tags %}

{% if routes %}
<table class="table table-dark table-striped table-hover table-sm">
    <caption class="sr-only">Routes table</caption>
    <thead>
    <tr>
        <th>Name</th>
        <th>Created</th>
        <th>Length</th>
        <th class="text-center">Tags</th>
        <th class="text-center">Status</th>
        <th class="text-center">Edit</th>
    </tr>
    </thead>
    <tbody>
    {% for route in routes %}
    <tr id="route{{ route.id }}">
        <td>
            <a href="{% url 'route:view' route.id %}">{{ route.name }}</a>
        </td>
        <td>{{ route.created|naturaltime }}</td>
        <td>{{ route.length|floatformat }} km</td>
        <td class="text-center">
            {% get_tags_for_object route as 'tags' %}
            {% for tag in tags|slice:':3' %}
            <a href="{% url 'tag:tag' tag.slug %}" class="badge badge-pill badge-secondary">{{ tag }}</a>
            {% endfor %}
            {% if tags|length > 3 %}
            <i class="badge badge-pill badge-secondary">...</i>
            {% endif %}
        </td>
        <td class="text-center status">
            {% if route.public %}
            <a href="#" title="public"><i class="fa fa-globe"></i></a>
            {% else %}
            <a href="#" title="private"><i class="fas fa-user-lock"></i></a>
            {% endif %}
        </td>
        <td class="text-center edit">
            <a href="{% url 'route:edit' route.id %}" title="edit"><i class="fas fa-edit"></i></a>
            {% if not route.public %}
            <a href="#" title="delete"><i class="fa fa-trash"></i></a>
            {% endif %}
        </td>
    </tr>
    {% endfor %}
    </tbody>
</table>
{% else %}
<div class="alert alert-info" role="alert">
    {% if active %}
    You don't have routes yet. Try to <a href="{% url 'route:create' %}" class="alert-link">create your first route</a>
    {% else %}
    <a href="{% url 'user:profile' profile %}"><b>{{ profile }}</b></a> has no public routes yet
    {% endif %}
</div>
{% endif %}

templates/partials/_tables.html
<div id="table-tracks" class="tab-pane fade active" role="tabpanel">
    {% include 'partials/_tracks-table.html' %}
</div>
<div id="table-routes" class="tab-pane fade" role="tabpanel">
    {% include 'partials/_routes-table.html' %}
</div>
<div id="table-pois" class="tab-pane fade" role="tabpanel">
    {% include 'partials/_pois-table.html' %}
</div>

templates/partials/_tag-table.html
{% load humanize %}

{% if not stories and not tracks and not routes and not pois %}
<div class="tab-pane fade active" role="tabpanel">
    <div class="alert alert-info" role="alert">
        There is nothing to show. Tag any item
    </div>
</div>
{% else %}
<div id="table-stories" class="tab-pane fade {% if stories %} active show {% endif %}" role="tabpanel">
    {% if stories %}
    <table class="table table-dark table-striped table-hover table-sm">
        <caption class="sr-only">Stories table</caption>
        <thead>
        <tr>
            <th>Name</th>
            <th>User</th>
            <th>Created</th>
        </tr>
        </thead>
        <tbody>
        {% for story in stories %}
        <tr id="story{{ story.id }}">
            <td>
                <a href="{% url 'story:view' story.id %}">{{ story.title }}</a>
            </td>
            <td>
                <a href="{% url 'user:profile' story.user %}">{{ story.user }}</a>
            </td>
            <td>{{ story.created|naturaltime }}</td>
        </tr>
        {% endfor %}
        </tbody>
    </table>
    {% endif %}
</div>

<div id="table-tracks" class="tab-pane fade {% if not stories and tracks %} active show {% endif %}" role="tabpanel">
    {% if tracks %}
    <table class="table table-dark table-striped table-hover table-sm">
        <thead>
        <tr>
            <th>Name</th>
            <th>User</th>
            <th>Length</th>
            <th>Created</th>
            <th class="text-center">Status</th>
        </tr>
        </thead>
        <tbody>
        {% for track in tracks %}
        <tr id="track{{ track.id }}">
            <td>
                <a href="{% url 'track:view' track.id %}">{{ track.name }}</a>
            </td>
            <td>
                <a href="{% url 'user:profile' track.user %}">{{ track.user }}</a>
            </td>
            <td>{{ track.length|floatformat }} km</td>
            <td>{{ track.start_date|naturaltime }}</td>
            <td class="text-center status">
                {% if track.public %}
                <i class="fa fa-globe" title="public"></i>
                {% else %}
                <i class="fas fa-user-lock" title="private"></i>
                {% endif %}
            </td>
        </tr>
        {% endfor %}
        </tbody>
    </table>
    {% endif %}
</div>

<div id="table-routes" class="tab-pane fade {% if not stories and not tracks and routes%} active show {% endif %}" role="tabpanel">
    {% if routes %}
    <table class="table table-dark table-striped table-hover table-sm">
        <thead>
        <tr>
            <th>Name</th>
            <th>User</th>
            <th>Length</th>
            <th>Created</th>
            <th class="text-center">Status</th>
        </tr>
        </thead>
        <tbody>
        {% for route in routes %}
        <tr id="route{{ route.id }}">
            <td>
                <a href="{% url 'route:view' route.id %}">{{ route.name }}</a>
            </td>
            <td>
                <a href="{% url 'user:profile' route.user %}">{{ route.user }}</a>
            </td>
            <td>{{ route.length|floatformat }} km</td>
            <td>{{ route.created|naturaltime }}</td>
            <td class="text-center status">
                {% if route.public %}
                <i class="fa fa-globe" title="public"></i>
                {% else %}
                <i class="fas fa-user-lock" title="private"></i>
                {% endif %}
            </td>
        </tr>
        {% endfor %}
        </tbody>
    </table>
    {% endif %}
</div>

<div id="table-pois" class="tab-pane fade {% if not stories and not tracks and not routes and pois%} active show {% endif %}" role="tabpanel">
    {% if pois %}
    <table class="table table-dark table-striped table-hover table-sm">
        <thead>
        <tr>
            <th>Name</th>
            <th>User</th>
            <th>Created</th>
            <th class="text-center">Status</th>
        </tr>
        </thead>
        <tbody>
        {% for poi in pois %}
        <tr id="poi{{ poi.id }}">
            <td>
                <a href="{% url 'poi:view' poi.id %}">{{ poi.name }}</a>
            </td>
            <td>
                <a href="{% url 'user:profile' poi.user %}">{{ poi.user }}</a>
            </td>
            <td>{{ poi.created|naturaltime }}</td>
            <td class="text-center status">
                {% if poi.public %}
                <i class="fa fa-globe" title="public"></i>
                {% else %}
                <i class="fas fa-user-lock" title="private"></i>
                {% endif %}
            </td>
        </tr>
        {% endfor %}
        </tbody>
    </table>
    {% endif %}
</div>
{% endif %}

templates/partials/_tracks-table.html
{% load humanize %}
{% load taggit_templatetags2_tags %}

{% if tracks %}
<table class="table table-dark table-striped table-hover table-sm">
    <caption class="sr-only">Tracks table</caption>
    <thead>
    <tr>
        <th>Name</th>
        <th>Started</th>
        <th>Length</th>
        <th class="text-center">Tags</th>
        <th class="text-center">Status</th>
        <th class="text-center">Edit</th>
    </tr>
    </thead>
    <tbody>
    {% for track in tracks %}
    <tr id="track{{ track.id }}">
        <td>
            <a href="{% url 'track:view' track.id %}">{{ track.name }}</a>
        </td>
        <td>{{ track.start_date|naturaltime }}</td>
        <td>{{ track.length|floatformat }} km</td>
        <td class="text-center">
            {% get_tags_for_object track as 'tags' %}
            {% for tag in tags|slice:':3' %}
            <a href="{% url 'tag:tag' tag.slug %}" class="badge badge-pill badge-secondary">{{ tag }}</a>
            {% endfor %}
            {% if tags|length > 3 %}
            <i class="badge badge-pill badge-secondary">...</i>
            {% endif %}
        </td>
        <td class="text-center status">
            {% if track.public %}
            <a href="#" title="public"><i class="fa fa-globe"></i></a>
            {% else %}
            <a href="#" title="private"><i class="fas fa-user-lock"></i></a>
            {% endif %}
        </td>
        <td class="text-center edit">
            <a href="{% url 'track:edit' track.id %}" title="edit"><i class="fas fa-edit"></i></a>
            {% if not track.public %}
            <a href="#" title="delete"><i class="fa fa-trash"></i></a>
            {% endif %}
        </td>
    </tr>
    {% endfor %}
    </tbody>
</table>
{% else %}
<div class="alert alert-info" role="alert">
    {% if active %}
    <form class="form" method="post" enctype="multipart/form-data" action="{% url 'table:view' %}">
        {% csrf_token %}
        You don't have Tracks yet. Try to
        <label>
            <input type="file" accept=".gpx" onchange="$('div.progress').show(); this.form.submit()" hidden name="gpx_file">
            <a  class="alert-link">import your first Track</a>
        </label>
    </form>
    {% else %}
    <a href="{% url 'user:profile' profile %}"><b>{{ profile }}</b></a> has no public tracks yet
    {% endif %}
</div>
{% endif %}